=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

module Shippo
  class PickupsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a pickup
    # Creates a pickup object.
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [BasePickup] :body Shippo’s pickups endpoint allows you to schedule pickups with USPS and DHL Express for eligible shipments that you have already created.
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @return [Pickup]
    def create_pickup(merchant_id, opts = {})
      data, _status_code, _headers = create_pickup_with_http_info(merchant_id, opts)
      data
    end

    # Create a pickup
    # Creates a pickup object.
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [BasePickup] :body Shippo’s pickups endpoint allows you to schedule pickups with USPS and DHL Express for eligible shipments that you have already created.
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @return [Array<(Pickup, Integer, Hash)>] Pickup data, response status code and response headers
    def create_pickup_with_http_info(merchant_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PickupsApi.create_pickup ...'
      end
      # verify the required parameter 'merchant_id' is set
      if @api_client.config.client_side_validation && merchant_id.nil?
        fail ArgumentError, "Missing the required parameter 'merchant_id' when calling PickupsApi.create_pickup"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/pickups/'.sub('{' + 'MerchantId' + '}', merchant_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'SHIPPO-API-VERSION'] = opts[:'shippo_api_version'] if !opts[:'shippo_api_version'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(opts[:'body']) 

      return_type = opts[:return_type] || 'Pickup' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PickupsApi#create_pickup\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
